indexing
	description:
	" Bietet Operationen auf einem String an, verwendet verschiedene Strategien zum Suchen in Texten"

class 
	Text 

creation 
	make

feature
	make (mitText: String; mitSucher: TextSucher) is
		--	Create-Funktion mit Angabe eines Textes und eines Suchalgorithmus
		do
			TextString:= mitText;
			Sucher:= mitSucher;
			MAXCHAR:= 256;
			MAXMUSTERLEN:= 50;
		end;
	getTextString: String is
		--	Zugriff auf TextString
		do
			result:= TextString
		end;
	Suche (Muster: String): Integer is
		--	Delgierung der Suche an die Strategie (Suchalg.)
		--	bergabe vom Muster und sich selbst, so dass der Algorithmus auf Text und 
		--	den String zugreifen kann
		do
			result:= Sucher.Suche(Muster, Current)
		end;

	setSucher (neuerSucher: TextSucher) is
			--	Neuen Suchalgorithmus einstellen
		require
			neuerSucher_nicht_leer: neuerSucher/= void
		do
			Sucher:= neuerSucher
		ensure
			neuerSucher_aktiv: Sucher= neuerSucher
		end;

	getMaxChar: Integer is
		do
			result:= MAXCHAR
		end;

feature {NONE}
	TextString	: String	-- Attribut zur Stringaufbewahrung
	MAXCHAR	: Integer	-- Maximales Zeichen (256)
	MAXMUSTERLEN	: Integer	-- Maximale Muster-Lnge
	Sucher		: TextSucher	-- Verweis auf Suchalgorithmus


end